unit UnitMaintest;

interface

uses
 Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,system.IOutils,
 Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ComCtrls, Vcl.ToolWin,System.Strutils,
  System.ImageList, Vcl.ImgList, Vcl.ExtCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    OpenDialog1: TOpenDialog;
    EditLevel: TEdit;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButtonRechnen: TToolButton;
    ToolButton3: TToolButton;
    StatusBar1: TStatusBar;
    ToolButton4: TToolButton;
    ImageList1: TImageList;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    EditMasstab: TEdit;
    Panel1: TPanel;
    EditdX: TEdit;
    EditdY: TEdit;
    EditdZ: TEdit;
    Editrx: TEdit;
    Editry: TEdit;
    Editrz: TEdit;
    Editm: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    ButtonTrafo: TButton;
    TrackBar1: TTrackBar;
    PaintBox1: TPaintBox;
    ToolButton2: TToolButton;
    LabelDeltaH: TLabel;
    EditDeltaH: TEdit;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    EditKantenwinkel: TEdit;
    Label4: TLabel;
    UpDown1: TUpDown;
    ToolButton7: TToolButton;
    Label8: TLabel;
    EditMasse: TEdit;
    ToolButton8: TToolButton;
    procedure FormActivate(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButtonRechnenClick(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ZeigSchnittlinie;
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    Procedure ZeigAlles;
    procedure EditMasstabExit(Sender: TObject);
    Procedure Transformation;
    procedure ButtonTrafoClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure ZMinMax;
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ToolButton2Click(Sender: TObject);
    procedure CalculateContour;
    Procedure CalcVolumen;
    Procedure ReadMesh;
    procedure EditLevelExit(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    Procedure CalcFaceNormals;
    Procedure BruchkanteFinden;
    procedure SchreibBruchkantenDXF;
    procedure SchreibDXF;
    Procedure DXFOpen;
    Procedure DXFClose;
    procedure DXFLinie(x1,y1,z1,x2,y2,z2:Double;Layer,LTyp:String);
    procedure DXFPunkt(x,y,z:Double;Layer,LTyp:String);
    procedure DXFText(x,y,z:Double;Text,Layer,LTyp:String;Alfa,Height:Real;Pos:Byte);
    procedure ToolButton6Click(Sender: TObject);
    procedure UpDown1Changing(Sender: TObject; var AllowChange: Boolean);
  private

    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;
  Tvertex=record
     x,y,z:double;
  end;

Type TPunkt=Record
     X,Y,Z:Double;
     ln:Shortint; // Vorkommen in Linien
     end;

  Tvect3D=array[0..2] of double;

  TFace=array[1..3] of Integer;

  TLine = record
    sp: Integer;
    ep: Integer;
    AE: Char;
   end;

  TContour = record
    Level:Double;
    Points:array of TPunkt;
    Contours: array of TLine;
  end;

  TLineCut = record
    ContourPt: Tpunkt;
    Found: Boolean;
  end;
  Tbruchkante=array[0..1] of Integer;
  TVertexFacePointer= array of Integer;
var
  Form1: TForm1;

  V:Array of Tvertex;
  Fc:Array of Tface;
  Vn,Fn:Array of TVect3D;

  vp:array of TvertexFacepointer;
  Contour:Tcontour;


  Bruchkanten:array of TBruchkante;

  PtTolerance,mf,xoffset,yoffset,zmin,zmax:Double;
  Mousesavex,mousesavey,mausposx,mausposy:Integer;

  DXFIsOpen:bOOLEAN;
  DXFFile:TextFile;
  DXFFileName:String;
  VertexFacePtr:array of array of integer;

implementation

{$R *.dfm}

uses OBJLoader,jpeg;

function sgn(x:Double):integer;
begin
  sgn:=0;
  if x<0 then sgn:=-1
  else if x>0 then sgn:=1;
end;

Procedure RIWI(dy,dx : Double;var S,T:Double);
(* Berechnet Richtungswinkel und Entfernung *)
Begin
  If DX = 0 Then T := sgn(dy)*Pi/2
  Else T := ArcTan(dy/DX);
  If DX < 0 Then T := T+Pi;
  If T < 0 Then T := T+Pi+Pi;
  S := Sqrt(dy*dy+DX*DX);
  If (DX = 0) And (dy = 0) Then
  begin
    T := 0;S:=0;
  end;
End;

Function arcsin(x : Double) : Double;
Begin
  if abs(x)>1 then
  begin
    writeln('FEHLER:ARCSIN Argument > 1');
    Halt(9);
  end;
  If Abs(x) = 1 Then arcsin := sgn(x)*Pi/2
  Else arcsin := ArcTan(x/Sqrt(1-x*x));
End;

Function arccos(x : Double) : Double;
Begin
  If x = 0 Then arccos := Pi/2
  Else
    If x < 0 Then arccos := Pi+ArcTan(Sqrt(1-x*x)/x)
    Else arccos := ArcTan(Sqrt(1-x*x)/x);
End;

function GetStr(var s:String):String;
var i:Integer;
begin
  Result:='';
  While (length(s)>0) and (s[1]=' ') do delete(s,1,1);
  i:=pos(' ',s);
  if i>0 then
  begin
    Result:=copy(s,1,i-1);
    delete(s,1,i-1);
    While (length(s)>0) and (s[1]=' ') do delete(s,1,1);
  end
  else
  begin
    Result:=s;
    s:='';
  end;
end;

function GetFloat(var Satz:String):Double;
var i:integer;
    s:string;
begin
  S:='';
  While (length(satz)>0) and (Satz[1]=' ') do delete(satz,1,1);
  i:=pos(' ',Satz);
  if i>0 then
  begin
    s:=copy(satz,1,i-1);
    delete(satz,1,i-1);
    While (length(satz)>0) and (Satz[1]=' ') do delete(satz,1,1);
  end
  else
  begin
    if satz>'' then s:=Satz;
    satz:='';
  end;
  i:=Pos(',',S);
  if i>0 then FormatSettings.DecimalSeparator:=',' else FormatSettings.DecimalSeparator:='.' ;
  try
   Result:=StrToFloatDef(s,0);
  except
    on EConvertError do
    begin
      Result:=0;
    end;
  end;

end;

function GetInt(var Satz:String):Integer;
var i:integer;
    s:string;
begin
  S:='';
  While (length(satz)>0) and (Satz[1]=' ') do delete(satz,1,1);
  i:=pos(' ',Satz);
  if i>0 then
  begin
    s:=copy(satz,1,i-1);
    delete(satz,1,i-1);
    While (length(satz)>0) and (Satz[1]=' ') do delete(satz,1,1);
  end
  else
  begin
    if satz>'' then s:=Satz;
    satz:='';
  end;

  try
   Result:=StrToIntDef(s,0);
  except
    on EConvertError do
    begin
      Result:=0;
    end;
  end;
end;

Function Kreuzprodukt(a,b:TVect3D):TVect3D;
var c:tVect3d;
begin
  c[0]:=a[1]*b[2]-a[2]*b[1];
  c[1]:=a[2]*B[0]-a[0]*b[2];
  c[2]:=a[0]*b[1]-a[1]*b[0];
  Result:=c;
end;

Function AddVect(a,b:Tvect3d):Tvect3d;
var c:TVect3d;
begin
  c[0]:=a[0]+b[0];
  c[1]:=a[1]+b[1];
  c[2]:=A[2]+b[2];
  Result:=c;
end;

Function SubVect(a,b:Tvect3d):Tvect3d;
var c:TVect3d;
begin
  c[0]:=a[0]-b[0];
  c[1]:=a[1]-b[1];
  c[2]:=A[2]-b[2];
  Result:=c;
end;

Function MultVect(a,b:Tvect3d):Double;
begin
  Result:=0;
  Result:=a[0]*b[0]+a[1]*b[1]+a[2]*b[2];
end;

Function ScalVect(a:Tvect3d;S:double):Tvect3d;
var
  c:Tvect3d;
begin
  c[0]:=A[0]*s;
  c[1]:=A[1]*s;
  c[2]:=A[2]*s;
  Result:=c;
end;

function NormVect(a:TVect3d):Tvect3D;
var s:Double;
    c:Tvect3d;
begin
  s:=sqrt(a[0]*a[0]+a[1]*a[1]+a[2]*a[2]);
  c[0]:=a[0]/s;
  c[1]:=a[1]/s;
  c[2]:=a[2]/s;
  result:=c;
end;

Function BetragVect(a:Tvect3d):Double;
begin
  result:=sqrt(a[0]*a[0]+a[1]*a[1]+a[2]*a[2]);
end;

Function WinkelVect(a,b:Tvect3d):double;
var x:double;
begin
  x:=multvect(a,b)/(BetragVect(a)*BetragVect(b));
  Result:=X;
end;


Procedure GetZMinMax;
var i:integer;
begin
  ZMax:=-1E13;Zmin:=-Zmax;
  for i:= 1 to High(v) do
  begin
    if V[i].z>Zmax Then Zmax:=V[i].z;
    if V[i].z<Zmin Then Zmin:=V[i].z;
  end;
end;


procedure Tform1.DXFOpen;
begin
  assignfile(DXFFile,DXFFileName);
  Rewrite(DXFFile);
  writeln(DXFFile,0:3);
  writeln(DXFFIle,'SECTION');
  Writeln(DXFFIle,2:3);
  Writeln(DXFFile,'ENTITIES');
  DXFIsOpen:=True;
end;

procedure Tform1.DXFClose;
begin
  if DXFIsOpen then
  begin
    Writeln(DXFFile,0:3);
    writeln(DXFFile,'ENDSEC');
    writeln(DXFFile,0:3);
    writeln(DXFFIle,'EOF');
    Closefile(DXFFIle);
    DXFIsOpen:=False;
  end;
end;

procedure Tform1.DXFLinie(x1,y1,z1,x2,y2,z2:Double;Layer,LTyp:String);
begin
  writeln(DXFFile,0:3);
  Writeln(DXFFIle,'LINE');
  writeln(DXFFile,8:3);
  Writeln(DXFFIle,LAYER);
  writeln(DXFFile,6:3);
  Writeln(DXFFIle,LTYP);
  writeln(DXFFile,10:3);
  Writeln(DXFFIle,X1);
  writeln(DXFFile,20:3);
  Writeln(DXFFIle,Y1);
  writeln(DXFFile,30:3);
  Writeln(DXFFIle,Z1);
  writeln(DXFFile,11:3);
  Writeln(DXFFIle,X2);
  writeln(DXFFile,21:3);
  Writeln(DXFFIle,Y2);
  writeln(DXFFile,31:3);
  Writeln(DXFFIle,Z2);
end;

procedure Tform1.DXFPunkt(x,y,z:Double;Layer,LTyp:String);
begin
  writeln(DXFFile,0:3);
  Writeln(DXFFIle,'POINT');
  writeln(DXFFIle,8:3);
  Writeln(DXFFIle,LAYER);
  Writeln(DXFFile,6:3);
  Writeln(DXFFile,LTyp);
  Writeln(DXFFile,10:3);
  writeln(DXFFile,X);
  Writeln(DXFFile,20:3);
  Writeln(DXFFile,Y);
  Writeln(DXFFile,30:3);
  Writeln(DXFFile,Z);
end;


procedure Tform1.DXFText(x,y,z:Double;Text,Layer,LTyp:String;Alfa,Height:Real;Pos:Byte);
begin
  writeln(DXFFile,0:3);
  Writeln(DXFFIle,'TEXT');
  writeln(DXFFIle,8:3);
  Writeln(DXFFIle,LAYER);
  Writeln(DXFFile,6:3);
  Writeln(DXFFile,LTyp);
  Writeln(DXFFile,10:3);
  writeln(DXFFIle,X);
  Writeln(DXFFile,20:3);
  Writeln(DXFFile,Y);
  Writeln(DXFFile,30:3);
  Writeln(DXFFile,Z);
  Writeln(DXFFile,40:3);
  Writeln(DXFFile,Height);
  Writeln(DXFFile,1:3);
  Writeln(DXFFile,Text);
  Writeln(DXFFile,50:3);
  Writeln(DXFFile,Alfa:10:4);
end;

Procedure DXFKreis(X,Y,z,Radius:Double;Layer,LTyp:String);
begin
  writeln(DXFFile,0:3);
  Writeln(DXFFIle,'CIRCLE');
  writeln(DXFFIle,8:3);
  Writeln(DXFFIle,LAYER);
  Writeln(DXFFile,6:3);
  Writeln(DXFFile,LTyp);
  Writeln(DXFFile,10:3);
  writeln(DXFFIle,X);
  Writeln(DXFFile,20:3);
  Writeln(DXFFile,-Y);
  Writeln(DXFFile,30:3);
  Writeln(DXFFile,Z);
  Writeln(DXFFile,40:3);
  Writeln(DXFFile,Radius);
end;

Procedure Tform1.CalcFaceNormals;
var i:integer;
    P1,p2,pn:tVect3d;
begin
  setlength(fn,1);
  Statusbar1.SimpleText:='Normale rechnen';
  StatusBar1.Update;
  for i:=1 to High(fc) do
  begin
    setlength(Fn,length(Fn)+1);
    p1[0]:=v[fc[i][2]].x-v[fc[i][1]].x;
    p1[1]:=v[fc[i][2]].y-v[fc[i][1]].y;
    p1[2]:=v[fc[i][2]].z-v[fc[i][1]].z;

    p2[0]:=v[fc[i][3]].x-v[fc[i][1]].x;
    p2[1]:=v[fc[i][3]].y-v[fc[i][1]].y;
    p2[2]:=v[fc[i][3]].z-v[fc[i][1]].z;
    pn:=Normvect(kreuzprodukt(p1,p2));
    fn[high(fn)]:=pn;
  end;
end;

procedure Tform1.BruchkanteFinden;
var
i,p1,p2: Integer;
NoLines: Integer;
cosMaxwinkel:Double;
sm:TvertexFacePointer;

procedure setVertexFacePointers;
var i,j,a,b,c:integer;
begin
   setlength(vp,high(v)+1);
   for i:=1 to high(fc) do
   begin
     a:=fc[i][1];b:=fc[i][2];c:=fc[i][3];
     for j:=low(vp[a]) to High(vp[a]) do if (vp[a][j]=i) then break;
     setlength(vp[a],length(vp[a])+1);
     vp[a][high(vp[a])]:=i;

     for j:=low(vp[b]) to High(vp[b]) do if (vp[b][j]=i) then break;
     setlength(vp[b],length(vp[b])+1);
     vp[b][high(vp[b])]:=i;

     for j:=low(vp[c]) to High(vp[c]) do if (vp[c][j]=i) then break;
     setlength(vp[c],length(vp[c])+1);
     vp[c][high(vp[c])]:=i;

   end;
end;

function CheckDoppelt:Boolean;
var i:Integer;
begin
  Result:=False;
  if high(Bruchkanten)<0 then exit;
  i:=-1;
  repeat
    inc(i);
    if ((Bruchkanten[i][0]=p1) and (Bruchkanten[i][1]=p2)) then Result:=true;
  until (Result=true) or (i=high(Bruchkanten));
end;

function Schnittmenge(a,b:TvertexFacepointer):Tvertexfacepointer;
var c:TvertexFacepointer;
    j,k:integer;
begin
  setlength(c,0);
  j:=0;k:=0;
  while(j <= high(a)) and (k <= high(b)) do
   if a[j]=b[k] then
   begin
     setlength(c,length(c)+1);
     c[high(c)]:=a[j];
     inc(j);inc(k);
   end
   else
     if a[j]>b[k] then inc(k)
     else inc(j);
   Result:=c;
end;

procedure CheckBruchkante;
var j:integer;
begin
  sm:=Schnittmenge(vp[p1],vp[p2]);
  if (length(sm)>1) and (cosmaxwinkel>winkelVect(fn[sm[0]],fn[sm[1]])) then
  begin
    if p1>p2 then
    begin
     j:=p1;p1:=p2;p2:=j;
    end;
    if Checkdoppelt=false then
    begin
      setlength(bruchkanten,Length(Bruchkanten)+1);
      bruchkanten[high(bruchkanten)][0]:=p1;
      bruchkanten[high(bruchkanten)][1]:=p2;
    end;
  end;
end;


begin
    Statusbar1.SimpleText:='Set vertexpointer...';
    SetVertexFacePointers;
    Setlength(Bruchkanten,0);
    NoLines:=0;
    setlength(vn,0);
    Statusbar1.SimpleText:='Calc face normals...';
    CalcFaceNormals;
    cosMaxwinkel:=cos(Strtofloat(editKantenwinkel.Text)/180*pi);
    Statusbar1.SimpleText:='Suche Kanten...';
    StatusBar1.Update;
    Application.ProcessMessages;
    i:=0;
    repeat
      inc(i);
       p1:=fc[i][1];p2:=fc[i][2];
       CheckBruchkante;
       p1:=fc[i][1];p2:=fc[i][3];
       CheckBruchkante;
       p1:=fc[i][2];p2:=fc[i][3];
       CheckBruchkante;
      until (i=high(fc));
    Form1.Statusbar1.SimpleText:=Format('%d Kanten gefunden',[high(Bruchkanten)+1]);
    form1.StatusBar1.Update;
end;

procedure Tform1.SchreibBruchkantenDXF;
var i:Integer;
    s:string;
    f:textfile;
begin
  s:=form1.editlevel.text;
  s:=replacestr(s,'.','_');
  DXFFilename:=extractfilepath(form1.Edit1.text)+'Bruchkanten.dxf';
  Form1.Statusbar1.SimpleText:=Format('%d Kanten gefunden schreibe '+DXFFilename,[High(Bruchkanten)+1]);
  form1.StatusBar1.Update;
  DXFOpen;
  for i:=0 to High(Bruchkanten) do
  begin
    dxfLinie(v[Bruchkanten[i][0]].x,v[Bruchkanten[i][0]].y,v[Bruchkanten[i][0]].z,
             v[Bruchkanten[i][1]].x,v[Bruchkanten[i][1]].y,v[Bruchkanten[i][1]].z,
             'Bruchkante','CONTINUOUS');
  end;
  DXFClose;
  Form1.Statusbar1.SimpleText:='Fertig!';
  form1.StatusBar1.Update;
end;

Procedure Tform1.ReadMesh;
var f:Textfile;
    satz,s:string;
    idstr:string[2];
    i,j:Integer;
   begin
   assignfile(f,form1.edit1.text);
   reset(f);
   setlength(v,1);
   setlength(fc,1);
   setlength(Vn,1);
   while not eof(f) do
   begin
     Readln(f,satz);
     idstr:=leftstr(satz,2);
     getstr(satz);
     if idstr= 'v ' then
      begin
        setlength(V,length(v)+1);
        i:=High(v);
        v[i].x:=Getfloat(satz);
        v[i].y:=getfloat(satz);
        v[i].z:=getfloat(satz);
      end
      else
      If Idstr='f ' then
      begin
        j:=0;
        setlength(fc,length(fc)+1);
        j:=High(fc);

        s:=getstr(satz);
        repeat
          i:=pos('/',s);
          if i>0 then s[i]:=' ';
        until i=0 ;
        fc[j][1]:=getint(s);

        s:=getstr(satz);
        repeat
          i:=pos('/',s);
          If i>0 then s[i]:=' ';
        until i=0 ;
        fc[j][2]:=getint(s);

        s:=getstr(satz);
        repeat
          i:=pos('/',s);
          If i>0 then s[i]:=' ';
        until i=0 ;
        fc[j][3]:=getint(s);
      end
      else
      if Idstr='vn' then
      begin
        setlength(Vn,length(Vn)+1);
        i:=high(Vn);
        Vn[i][0]:=getfloat(satz);
        Vn[i][1]:=getfloat(satz);
        Vn[i][2]:=getfloat(satz);
      end;

   end;
  closefile(f);
  Form1.ZMinmax;
  Form1.label2.caption:=Format('Schnitthhe %4.3f - %4.3f',[zmin,zmax]);
  Form1.TRackbar1.position:=Form1.TrackBar1.SelEnd div 2;
  Form1.TrackBar1.Update;
  Form1.EditLevel.Text:=format('%4.3f',[(zmin+zmax)/2]);

end;


procedure TForm1.EditLevelExit(Sender: TObject);
begin
  CalculateContour;
  zeigschnittlinie;
end;

procedure TForm1.EditMasstabExit(Sender: TObject);
begin
  MF:=strtofloat(Editmasstab.Text);
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  FormatSettings.DecimalSeparator:='.';
  FormatSettings.ThousandSeparator:=#0;
  FormatSettings.DateSeparator:='.';
  FormatSettings.ShortDateFormat:='dd.mm.yyyy';

end;


procedure SortContourLines;
var i,j:integer;

procedure SwapAE(var HL:TLine);
var i:integer;
begin
  i:=HL.EP;
  HL.EP:=HL.SP;
  HL.SP:=i;
end;

function SuchNachfolger(n:integer):Integer;
var i:integer;
begin
  for i:=low(contour.Contours) to high(contour.contours) do
  begin
    if  (Contour.Points[contour.Contours[n].sp].X=Contour.Points[contour.Contours[i].sp].X)
    and (Contour.Points[contour.Contours[n].sp].y=Contour.Points[contour.Contours[i].sp].y) and
    (Contour.Contours[i].AE='') then
    begin
      result:=i;
      exit;
    end;
    if  (Contour.Points[contour.Contours[n].ep].X=Contour.Points[contour.Contours[i].ep].X)
    and (Contour.Points[contour.Contours[n].ep].y=Contour.Points[contour.Contours[i].ep].y) and
    (Contour.Contours[i].AE='') then
    begin
      swapAE(contour.Contours[i]);
      result:=i;
      exit;
    end;
  end;
  Result:=-1;
end;

procedure SwapHLPolY(i,k:Integer);
var HL:TLine;
begin
  HL.sp:=Contour.Contours[i].sp;
  HL.ep:=Contour.Contours[i].ep;
  HL.ae:=Contour.Contours[i].ae;
  Contour.Contours[i].sp:=Contour.Contours[k].sp;
  Contour.Contours[i].ep:=Contour.Contours[k].ep;
  Contour.Contours[i].ae:=Contour.Contours[k].ae;
  Contour.Contours[k].sp:=HL.sp;
  Contour.Contours[k].ep:=HL.ep;
  Contour.Contours[k].ae:=HL.ae;
end;


function Endpunkt(ep:Integer):Boolean;
var j,n:Integer;
begin
  Result:=False;
  n:=0;
  for j:=Low(Contour.Contours) to high(Contour.Contours) do
    if (Contour.Contours[j].sp=ep) or (Contour.Contours[j].ep=ep) then
    inc(n);
  Result:=(n=1);
end;

function Afangspunkt(i:Integer):Boolean;
var j,sp:Integer;
begin
  Result:=False;
  sp:=Contour.Contours[i].sp;
  for j:=Low(Contour.Contours) to high(Contour.Contours) do
    if (Contour.Contours[j].sp=sp) or (Contour.Contours[j].ep=sp) and (j<>i) then
    Result:=True;
end;

FUNCTION IsNextLine(a,b:integer):Boolean;
begin
  Result:=false;
  Result:=(contour.Points[contour.Contours[a].ep].X=contour.Points[contour.Contours[b].sp].x);
  If (contour.Points[contour.Contours[a].ep].X=contour.Points[contour.Contours[b].ep].x) then
  begin
    swapAE(contour.Contours[b]);
    Result:=True;
  end;
end;

begin
  j:=0;
  for i:=0 to high(contour.contours) do
  begin
    repeat
      j:=suchnachfolger(j);
      if j>=0 then
      If Endpunkt(j) then contour.contours[j].AE:='A'
      else contour.Contours[j].AE:='L';
    until j<0;
    j:=i+1;
  end;
end;

function LineCut(x1,y1,x2,y2,z1,z2,Level: Double): TLineCut;
var
fraction: Double;
begin
 Result.Found:=False;
 if ((z1<=Level) and (z2>Level)) or ((z2<=Level) and (z1>Level)) then
 begin
  fraction:=(z1-Level) / (z1-z2);
  Result.ContourPt.X:=x1 + ((x2-x1)*fraction);
  Result.ContourPt.Y:=y1 + ((y2-y1)*fraction);
  Result.Found:=True;
 end;
end;

function AddContourPoint(P:Tpunkt):Integer;
var i:Integer;
begin
  i:=0;
  while (i<high(Contour.Points)) and
     ((abs(Contour.Points[i].X-P.X)>PtTolerance) or (abs(Contour.Points[i].Y-P.Y)>PtTolerance)) do inc(i);

  if (length(Contour.Points)=0) or
    ((abs(Contour.Points[i].X-P.X)>PtTolerance) or
    (abs(Contour.Points[i].Y-P.Y)>PtTolerance)) then
  begin
    setlength(Contour.Points,length(Contour.Points)+1);
    Result:=high(Contour.Points);
    Contour.Points[Result].X:=P.X;
    Contour.Points[Result].Y:=P.Y;
    Contour.Points[Result].ln:=0;
  end
  else Result:=i;
end;

procedure AddContourLine(L1,L2:TLineCut);
var i,sp,ep:Integer;
begin
  sp:=AddContourPoint(L1.ContourPt);
  ep:=AddContourPoint(L2.ContourPt);
  if (sp>=0) and (sp<=high(Contour.points)) and
     (ep>=0) and (ep<=high(Contour.points)) then
  begin
    SetLength(Contour.Contours,length(contour.Contours)+1);
    i:=high(Contour.Contours);
    Contour.Contours[i].sp:=sp;
    Contour.Contours[i].ep:=ep;
    Contour.Contours[i].ae:=#0;
  end;
end;

procedure Tform1.CalculateContour;
var
line1, line2, line3: TLineCut;
i: Integer;
NoLines: Integer;
xa,ya,za,xb,yb,zb,xc,yc,zc: Double;

begin
    setlength(contour.Points,0);
    setlength(contour.Contours,0);
    NoLines:=0;
    PtTolerance:=0.02;
    Contour.Level:=StrtoFloat(Form1.EditLevel.text);
    for i:=1 to high(fc) do
    begin
      xa:=V[fc[i][1]].x;
      ya:=V[fc[i][1]].y;
      za:=V[fc[i][1]].z;
      xb:=V[fc[i][2]].x;
      yb:=v[fc[i][2]].y;
      zb:=v[fc[i][2]].z;
      xc:=v[fc[i][3]].x;
      yc:=v[fc[i][3]].y;
      zc:=v[fc[i][3]].z;

      line1:= LineCut( xa,ya, xb,yb, za,zb, Contour.Level);
      line2:= LineCut( xb,yb, xc,yc, zb,zc, Contour.Level);
      line3:= LineCut( xc,yc, xa,ya, zc,za, Contour.Level);

      if (not line1.Found) then
      begin
        if (line2.Found) and (line3.Found) then
          AddConTourLine(Line2,Line3);
      end;

      if (not line2.Found) then
      begin
        if (line1.Found) and (line3.Found) then
          AddConTourLine(Line1,Line3);
      end;

      if (not line3.Found) then
      begin
        if (line1.Found) and (line2.Found) then
           AddConTourLine(Line1,Line2);
      end;
    end;
  //  SortContourLines;
   CalcVolumen;
end;


procedure Tform1.ZeigAlles;
var i,xmax,ymax:integer;
begin
  XMax:=Form1.Width;
  YMax:=Form1.Height;
  Paintbox1.Height:=YMax-100;
  PaintBox1.Width:=XMax;
  PaintBox1.Canvas.Brush.Style:=BsSolid;
  PaintBox1.Canvas.Brush.Color:=clWhite;
  PaintBox1.canvas.FillRect(Rect(0,0,PaintBox1.width,PaintBox1.height));
  PaintBox1.Canvas.pen.color:=clred;
  for i:=0 to high(contour.Contours) do
  begin
    PaintBox1.Canvas.Moveto(Trunc((Contour.points[contour.Contours[i].sp].x-xoffset)/MF),Trunc(-(Contour.points[contour.Contours[i].sp].y-yoffset)/MF));
    PaintBox1.canvas.LineTo(Trunc((Contour.points[contour.Contours[i].ep].x-xoffset)/MF),Trunc(-(Contour.points[contour.Contours[i].ep].y-yoffset)/MF));
  end;
end;

procedure TForm1.ZeigSchnittlinie;
var
    i:Integer;
    XMax,YMax,xMin,yMin:Double;
begin
  //  Bitmap.canvas.FillRect(Bitmap.BoundsRect);
//   PaintBox1.Picture.Bitmap.Height:=PaintBox1.Height;
//   PaintBox1.Picture.Bitmap.Width:=PaintBox1.width;
   PaintBox1.Canvas.Font.Size:=8;
   MF:=Strtofloat(EditMasstab.Text);
   YOffset:=1E14;Xoffset:=1E14;
  PaintBox1.Canvas.Pen.Color:=ClBlack;
  PaintBox1.Canvas.Brush.Style:=BsSolid;
  PaintBox1.Canvas.Brush.Color:=clWhite;
  PaintBox1.canvas.FillRect(Rect(0,0,PaintBox1.width,PaintBox1.height));
  PaintBox1.Canvas.Pen.Width:=1;
  PaintBox1.canvas.Pen.Style:=PsSolid;
  SetBKColor(PaintBox1.Canvas.Brush.Handle,clWhite);
//  PrinterPreview;
  PaintBox1.Canvas.Brush.Style:=bsClear;
  //AktSetBKMode(AktCanvas.Handle,1);
  PaintBox1.Canvas.Font.Name:='Arial';
  PaintBox1.Canvas.Font.Color:=ClBlack;
  XMin:=1E12;YMin:=1E12;
  XMax:=-1E12;YMax:=-1E12;
  with Contour do
  begin
    for i:=0 to high(Contours) do
    begin
     if Points[contours[i].sp].X>XMax then XMax:=Points[contours[i].sp].X;
     if Points[contours[i].ep].X>XMax then XMax:=Points[contours[i].ep].X;
     if Points[contours[i].sp].X<XMin then XMin:=Points[contours[i].sp].X;
     if Points[contours[i].ep].X<Xmin then XMin:=Points[contours[i].ep].X;

     if Points[contours[i].sp].Y>YMax then YMax:=Points[contours[i].sp].Y;
     if Points[contours[i].ep].Y>YMax then YMax:=Points[contours[i].ep].Y;
     if Points[contours[i].sp].Y<YMin then YMin:=Points[contours[i].sp].Y;
     if Points[contours[i].ep].Y<Ymin then YMin:=Points[contours[i].ep].Y;
    end;
  end;
  YOffset:=YMax;XOffset:=XMin;
  MF:=(xmax-xmin)/PaintBox1.Width;
  EditMasstab.Text:=Format('%10.6f',[1/MF]);
  ZeigAlles;
end;

procedure Tform1.SchreibDXF;
var i:Integer;
    s:string;
begin
  s:=form1.editlevel.text;
  s:=replacestr(s,'.','_');
  DXFFilename:=extractfilepath(form1.Edit1.text)+'S'+s+'.dxf';
  DXFOpen;
  for i:=0 to High(contour.Contours) do
  begin
    dxfLinie(contour.Points[contour.Contours[i].sp].x,contour.Points[contour.Contours[i].sp].y,contour.Level,
            contour.Points[contour.Contours[i].ep].x,contour.Points[contour.Contours[i].ep].y,contour.Level,
    'SCHNITT'+form1.editlevel.text,'CONTINUOUS');
  end;
  DXFClose;
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
  if opendialog1.execute then
  begin
    edit1.Text:=opendialog1.FileName;
    edit1.Update;
  end;
  Screen.Cursor:=crHourglass;
  Form1.Statusbar1.SimpleText:='OBJ-Datei lesen ...';
  Readmesh;
  Form1.Statusbar1.SimpleText:=Format('%d Vertices %d Verticenormals %d Faces geladen',[high(v)+1,high(vn)+1,high(fc)+1]);
  form1.StatusBar1.Update;
  Screen.Cursor:=crDefault;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
  If Toolbutton2.Down=True then
  begin
    Statusbar1.Simpletext:='Bitte nacheinander zwei Punkte anklicken';
    screen.Cursor:=crCross;
  end
  else screen.Cursor:=crDefault;
end;

procedure TForm1.ToolButtonRechnenClick(Sender: TObject);
begin
  Screen.Cursor:=crHourglass;
  Form1.Statusbar1.SimpleText:='Rechnen...';
  ZMinmax;
  CalculateContour;
  ZeigSchnittlinie;
  Form1.Statusbar1.SimpleText:=Format('Fertig: Schnittlinie %d Punkte %d Linien',[high(contour.Points)+1,high(contour.Contours)+1]);
  Screen.Cursor:=crDefault;

end;

procedure TForm1.ToolButton3Click(Sender: TObject);
begin
  Schreibdxf;
  Form1.Statusbar1.SimpleText:='DXF Datei von Schnittlinie erzeugt';
end;

procedure TForm1.ToolButton4Click(Sender: TObject);
var i:Integer;
  s:string;
begin
  Screen.Cursor:=crHourglass;
  Form1.Statusbar1.SimpleText:=Format('Schreibe %d Faces...',[high(fc)+1]);

  s:=Tpath.Changeextension(form1.Edit1.Text,'DXF');
  DXFFilename:=s;
  DXFOpen;

  for i:=0 to High(fc) do
  begin
    dxfLinie(v[fc[i][1]].y,v[fc[i][1]].x,v[fc[i][1]].z,
             v[fc[i][2]].y,v[fc[i][2]].x,v[fc[i][2]].z,'FACE','CONTINUOUS');
    dxfLinie(v[fc[i][1]].y,v[fc[i][1]].x,v[fc[i][1]].z,
             v[fc[i][3]].y,v[fc[i][3]].x,v[fc[i][3]].z,'FACE','CONTINUOUS');
    dxfLinie(v[fc[i][2]].y,v[fc[i][2]].x,v[fc[i][2]].z,
             v[fc[i][3]].y,v[fc[i][3]].x,v[fc[i][3]].z,'FACE','CONTINUOUS');
  end;

 DXFClose;
 Screen.Cursor:=crDefault;
end;


procedure TForm1.ToolButton5Click(Sender: TObject);
var i:Integer;
    H,dh:double;
    Layer:string;
begin
  Screen.Cursor:=crHourglass;
  DXFFilename:=extractfilepath(form1.Edit1.text)+'Schnitte.dxf';
  DXFOpen;
  dh:=Strtofloat(editdeltah.text);
  H:=Trunc(zmin/dh)*dh;
  repeat
    editLevel.text:=format('%8.3f',[H]);
    Layer:=Format('S%8.3fd',[H]);
    calculateContour;
    ZeigAlles;
    for i:=0 to High(contour.Contours) do
    begin
    dxfLinie(contour.Points[contour.Contours[i].sp].x,contour.Points[contour.Contours[i].sp].y,contour.Level,
            contour.Points[contour.Contours[i].ep].x,contour.Points[contour.Contours[i].ep].y,contour.Level,
    Layer,'CONTINUOUS');
  end;
  h:=h+dh;
  until h>zmax;
  DXFClose;
  screen.cursor:=crdefault;
end;


procedure TForm1.ToolButton6Click(Sender: TObject);
begin
  Bruchkantefinden;
  SchreibBruchkantenDXF;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var s,t:Double;
begin
  if (Button=mbLeft) and (Toolbutton2.Down=true) then
  begin
    Riwi(y-Mousesavey,x-Mousesavex,s,t);
    statusbar1.SimpleText:=format('s=%10.3f t=%10.4f',[s*MF,t*180/Pi]);
  end;
  MouseSaveX:=X;
  MouseSaveY:=Y;
end;

procedure TForm1.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if ssleft in shift then
  begin
    Yoffset:=YOffset-(MouseSaveY-Y)*MF;
    Xoffset:=XOffset+(MouseSaveX-X)*MF;
    MouseSaveX:=X;
    MouseSaveY:=Y;
    ZeigAlles;
  end;
 // Statusbar1.SimpleText:=format('%5d %5d %8.3f %8.3f %8.3f %8.3f',[x,y,xoffset,yoffset,x*MF+xoffset,-y*MF+yoffset]);
end;

procedure TForm1.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button=mbright then
  begin
    Yoffset:=YOffset-(MouseSaveY-Y)*MF;
    Xoffset:=XOffset+(MouseSaveX-X)*MF;
    MouseSaveX:=X;
    MouseSaveY:=Y;
   ZeigAlles;
  end;

end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
var X,Y:Integer;
begin
  Screen.Cursor:=crHourGlass;
  x:=mousepos.X;
  y:=mousepos.Y;
  MF:=MF*1.25;
//  Yoffset:=YOffset+y*MF;
//  XOffset:=XOffset-x*MF;
  EditMasstab.Text:=Format('%10.6f',[1/MF]);
  ZeigAlles;
  Screen.Cursor:=crDefault;
  Handled:=True;
end;


procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
var X,Y:Integer;
begin
  Screen.Cursor:=crHourGlass;
  x:=Mousepos.X;
  y:=MousePos.Y;
  MF:=MF/1.25;
//  Yoffset:=YOffset+y*MF;
//  XOffset:=XOffset-x*MF;
  EditMasstab.Text:=Format('%10.6f',[1/MF]);
  ZeigAlles;
  Screen.Cursor:=crDefault;
  Handled:=True;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  //ZMinmax;
  EditLevel.Text:=Format('%4.3f',[TRackbar1.Position/Trackbar1.SelEnd*(zmax-zmin)+Zmin]);
  CalculateContour;
  ZeigSchnittlinie;
end;

Procedure Tform1.Transformation;
var i:integer;
    M,xn,yn,zn,rx,ry,rz,dx,dy,dz:Double;
    R:array[1..3,1..3] of double;
begin
  dx:=Strtofloat(editdX.text);  dy:=Strtofloat(editdy.text);  dz:=Strtofloat(editdZ.text);
  rx:=Strtofloat(editrX.text)*Pi/180;  ry:=Strtofloat(editry.text)*PI/180;  rz:=Strtofloat(editrZ.text)*Pi/180;
  M:=Strtofloat(editM.text);
  R[1,1]:=cos(ry)*cos(rz);   R[1,2]:=-cos(ry)*sin(rz);  R[1,3]:=sin(ry);

  R[2,1]:=cos(rx)*sin(rz)+sin(rx)*sin(ry)*cos(rz);
  R[2,2]:=cos(rx)*cos(rz)-sin(rx)*sin(ry)*sin(rz);
  R[2,3]:=-sin(rx)*cos(ry);

  R[3,1]:=sin(rx)*sin(rz)-cos(rx)*sin(ry)*cos(rz);
  R[3,2]:=sin(rx)*cos(rz)+cos(rx)*sin(ry)*sin(rz);
  R[3,3]:=cos(rx)*cos(ry);

  for i:=1 to high(V) do
  begin
    XN:=dx+M*(R[1,1]*v[i].X+R[1,2]*v[i].y+R[1,3]*v[i].z);
    YN:=dy+M*(R[2,1]*v[i].X+R[2,2]*v[i].y+R[2,3]*v[i].z);
    ZN:=dz+M*(R[3,1]*v[i].X+R[3,2]*v[i].y+R[3,3]*v[i].Z);
    v[i].x:=xN;v[i].y:=yn;v[i].z:=zn;
  end;
  Form1.label2.caption:=Format('Schnitthhe %4.3f - %4.3f',[zmin,zmax]);
end;

procedure TForm1.UpDown1Changing(Sender: TObject; var AllowChange: Boolean);
begin
  editkantenwinkel.Text:=inttostr(updown1.Position);
end;

Procedure Tform1.ZMinmax;
var i:Integer;
begin
  zmax:=V[1].Z;Zmin:=Zmax;
  for i:=1 to higH(v) do
  begin
    if V[i].Z<zmin then zmin:=V[i].Z;
    if V[i].Z>zmax then zmax:=V[i].Z
  end;
end;

procedure TForm1.ButtonTrafoClick(Sender: TObject);
begin
  Transformation;
  ZMinmax;
  EditLevel.Text:=Format('%10.3f',[(zmax+zmin)/2]);
  Form1.label2.caption:=Format('Schnitthhe %4.3f - %4.3f',[zmin,zmax]);
  CalculateContour;
  ZeigSchnittlinie;
end;

Procedure Tform1.CalcVolumen;
var i,i0,i1,i2:integer;
    A,SumA0,H0,ma,masse:Double;
begin
  masse:=0;SumA0:=0;
  h0:=StrtoFloat(Form1.EditLevel.text);
  for i:=low(Fc) to high(fc) do
  begin
     i0:=fc[i][1];
     i1:=fc[i][2];
     i2:=fc[i][3];
     A:=abs(V[i0].X*(V[i1].Y-V[i2].Y)+
            V[i1].X*(V[i2].Y-V[i0].Y)+
            V[i2].X*(V[i0].Y-V[i1].Y))/2;
    SumA0:=SumA0+A;
    if (v[i0].z>H0) and (v[i1].z>H0) and (V[i2].Z>H0) then
      masse:=Masse+A*((v[i0].Z+v[i1].Z+v[i2].Z)/3-H0);
  end;
  editmasse.Text:=Format('%6.0f',[masse]);
end;

end.
